/****************************************************************************
**
** DCOP Stub Implementation created by dcopidl2cpp from xparthost.kidl
**
** WARNING! All changes made in this file will be lost!
**
*****************************************************************************/

#include "xparthost_stub.h"
#include <dcopclient.h>

#include <kdatastream.h>


XPartHost_stub::XPartHost_stub( const TQCString& app, const TQCString& obj )
  : DCOPStub( app, obj )
{
}

XPartHost_stub::XPartHost_stub( DCOPClient* client, const TQCString& app, const TQCString& obj )
  : DCOPStub( client, app, obj )
{
}

XPartHost_stub::XPartHost_stub( const DCOPRef& ref )
  : DCOPStub( ref )
{
}

DCOPRef XPartHost_stub::registerXPart( const DCOPRef& arg0 )
{
    DCOPRef result;
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return result;
    }
    TQByteArray data, replyData;
    TQCString replyType;
    TQDataStream arg( data, IO_WriteOnly );
    arg << arg0;
    if ( dcopClient()->call( app(), obj(), "registerXPart(DCOPRef)", data, replyType, replyData ) ) {
	if ( replyType == "DCOPRef" ) {
	    TQDataStream _reply_stream( replyData, IO_ReadOnly );
	    _reply_stream >> result;
	    setStatus( CallSucceeded );
	} else {
	    callFailed();
	}
    } else { 
	callFailed();
    }
    return result;
}

DCOPRef XPartHost_stub::part()
{
    DCOPRef result;
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return result;
    }
    TQByteArray data, replyData;
    TQCString replyType;
    if ( dcopClient()->call( app(), obj(), "part()", data, replyType, replyData ) ) {
	if ( replyType == "DCOPRef" ) {
	    TQDataStream _reply_stream( replyData, IO_ReadOnly );
	    _reply_stream >> result;
	    setStatus( CallSucceeded );
	} else {
	    callFailed();
	}
    } else { 
	callFailed();
    }
    return result;
}

void XPartHost_stub::createActions( const TQCString& arg0 )
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    TQDataStream arg( data, IO_WriteOnly );
    arg << arg0;
    dcopClient()->send( app(), obj(), "createActions(TQCString)", data );
    setStatus( CallSucceeded );
}

void XPartHost_stub::setWindowCaption( const TQString& arg0 )
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    TQDataStream arg( data, IO_WriteOnly );
    arg << arg0;
    dcopClient()->send( app(), obj(), "setWindowCaption(TQString)", data );
    setStatus( CallSucceeded );
}

void XPartHost_stub::setStatusBarText( const TQString& arg0 )
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    TQDataStream arg( data, IO_WriteOnly );
    arg << arg0;
    dcopClient()->send( app(), obj(), "setStatusBarText(TQString)", data );
    setStatus( CallSucceeded );
}

void XPartHost_stub::started()
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    dcopClient()->send( app(), obj(), "started()", data );
    setStatus( CallSucceeded );
}

void XPartHost_stub::completed()
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    dcopClient()->send( app(), obj(), "completed()", data );
    setStatus( CallSucceeded );
}

void XPartHost_stub::canceled( const TQString& arg0 )
{
    if ( !dcopClient()  ) {
	setStatus( CallFailed );
	return;
    }
    TQByteArray data;
    TQDataStream arg( data, IO_WriteOnly );
    arg << arg0;
    dcopClient()->send( app(), obj(), "canceled(TQString)", data );
    setStatus( CallSucceeded );
}


